package types

/* ---------------------------------------------------------------- *
 * IMPORTS
 * ---------------------------------------------------------------- */

//

/* ---------------------------------------------------------------- *
 * YAML SCHEMES
 * ---------------------------------------------------------------- */

type UserConfig struct {
	Info  *InfoConfig  `yaml:"info"`
	Parts *PartsConfig `yaml:"parts"`
}

type InfoConfig struct {
	Title       *string `yaml:"title"`
	Description *string `yaml:"description"`
}

type PartsConfig struct {
	Cases *([]CaseConfig) `yaml:"cases"`
}

type CaseConfig struct {
	Command     *string       `yaml:"command"`
	Description *string       `yaml:"description"`
	Inputs      *InputsConfig `yaml:"inputs"`
}

type InputsConfig struct {
	List        *[]int `yaml:"L"`
	SearchRank  *int   `yaml:"i"`
	SearchValue *int   `yaml:"x"`
	JumpSize    *int   `yaml:"m"`
}
